#define _CRT_SECURE_NO_DEPRECATE
#define _USE_MATH_DEFINES
#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <climits>
#include <ctime>
#include <numeric>
#include <vector>
#include <algorithm>
#include <bitset>
#include <cmath>
#include <cstring>
#include <iomanip>
#include <complex>
#include <deque>
#include <functional>
#include <list>
#include <map>
#include <string>
#include <sstream>
#include <set>
#include <stack>
#include <queue>
using namespace std;
typedef long long LL;
typedef unsigned long long ULL;
typedef unsigned int uint;
typedef unsigned char uchar;
typedef double ld;
typedef pair<int, int> pii;
typedef pair<short, short> pss;
typedef pair<LL, LL> pll;
typedef pair<ULL, ULL> puu;
typedef pair<ld, ld> pdd;
template<class T> inline T sqr(T x) { return x * x; }
template<class T> inline string tostr(const T & x) { stringstream ss; ss << x; return ss.str(); }
inline LL parse(const string & s) { stringstream ss(s); LL x; ss >> x; return x; }
#define left asdleft
#define right asdright
#define link asdlink
#define unlink asdunlink
#define next asdnext
#define prev asdprev
#define y0 asdy0
#define y1 asdy1
#define mp make_pair
#define pb push_back
#define sz(x) ((int)(x).size())
#define all(x) (x).begin(), (x).end()
#define clr(ar,val) memset(ar, val, sizeof(ar))
#define istr stringstream
#define forn(i,n) for(int i=0;i<(n);++i)
#define forv(i,v) forn(i,sz(v))
#define X first
#define Y second
#define hash asdhash
#define move asdmove
const ld EPS = 1e-9;
const int inf = 1000*1000*1000;
const char cinf = 102;
const LL linf = inf * 1ll * inf;
const ld dinf = 1e200;
const ld PI = 3.1415926535897932384626433832795l;
int gcd(int a,int b){return a?gcd(b%a,a):b;}
LL gcd(LL a,LL b){return a?gcd(b%a,a):b;}
LL powmod(LL a,LL p,LL m){LL r=1;while(p){if(p&1)r=r*a%m;p>>=1;a=a*a%m;}return r;}
#define FAIL { cerr<<"assertion failed on line "<<__LINE__<<endl; exit(123);}

struct chain {
  vector<int> P,D;

  void init(const string& s,char c){
    int p=-1;
    forv(i,s){
      if(s[i]==c){
        P.pb(i);
        if(p!=-1)
          D.pb(i-p);
        p=i;
      }
    }
  }

  vector<char> find(vector<int> d){
    if(sz(D)<sz(d))
      return vector<char>();
    int sd=sz(d);
    d.pb(inf);
    d.insert(d.end(),D.begin(),D.end());
    vector<int> p(sz(d)+1);
    for(int i=2;i<=sz(d);++i){
      int k=p[i-1];
      while(k && d[k]!=d[i-1])
        k=p[k];
      if(d[k]==d[i-1])
        p[i]=k+1;
      else
        p[i]=0;
    }
    vector<char> r(sz(D)-sd+1);
    forv(i,r){
      r[i]=p[i+sd+1+sd]==sd;
    }
    return r;
  }
};

string S,T;

void gen(){
  freopen("in.txt","w",stdout);
  forn(i,200000){
    cout<<(char)('a'+rand()%26);
  }
  cout<<endl;
  forn(i,100000){
    cout<<(char)('a'+rand()%26);
  }
}

int main(){
	ios_base::sync_with_stdio(false);cin.tie(0);

  cin>>S>>T;
  cin>>S>>T;
  chain sc[26],tc[26];
  cerr<<"A"<<endl;
  forn(i,26){
    sc[i].init(S,'a'+i);
    tc[i].init(T,'a'+i);
  }
  cerr<<"B"<<endl;
  vector<char> in[26][26];
  forn(i,26){
    forn(j,26){
      in[i][j]=sc[j].find(tc[i].D);
    }
  }
  cerr<<"C"<<endl;

  vector<int> ans;
  forn(p,sz(S)-sz(T)+1){
    bool ok=true;
    //cerr<<p<<endl;
    vector<int> to(26,-1);
    forn(a,26){
      if(!sz(tc[a].P)){
        continue;
      }
      int b=S[p+tc[a].P[0]]-'a';
      if(to[a]!=-1 && to[a]!=b){
        ok=false;
        break;
      }
      if(to[b]!=-1 && to[b]!=a){
        ok=false;
        break;
      }
      to[b]=a;
      to[a]=b;
      //cerr<<" "<<a<<' '<<b<<endl;
      auto& sb=sc[b];
      if(!sz(sb.P)){
        ok=false;
        break;
      }
      int i=lower_bound(all(sb.P),p+tc[a].P[0])-sb.P.begin();
      assert(sb.P[i]==p+tc[a].P[0]);
      if(i && sb.P[i-1]>=p){
        ok=false;
        break;
      }
      if(i+sz(tc[a].P)>sz(sb.P)){
        ok=false;
        break;
      }
      if(i+sz(tc[a].P)<sz(sb.P) && sb.P[i+sz(tc[a].P)]<p+sz(T)){
        ok=false;
        break;
      }
      if(!in[a][b][i]){
        ok=false;
        break;
      }
    }
    if(ok)
      ans.pb(p);
  }

  cout<<sz(ans)<<endl;
  forv(i,ans){
    cout<<ans[i]+1<<' ';
  }

  //gen();

  return 0;
}

